Gentoo Archives: gentoo-commits

From: "Lars Wendler (polynomial-c)" <polynomial-c@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] gentoo-x86 commit in dev-vcs/git: git-2.4.7.ebuild ChangeLog
Date: Fri, 31 Jul 2015 15:10:45
Message-Id: 20150731151038.A79A1110@oystercatcher.gentoo.org
1 polynomial-c 15/07/31 15:10:38
2
3 Modified: ChangeLog
4 Added: git-2.4.7.ebuild
5 Log:
6 Version bump
7
8 (Portage version: 2.2.20/cvs/Linux x86_64, signed Manifest commit with key 981CA6FC)
9
10 Revision Changes Path
11 1.352 dev-vcs/git/ChangeLog
12
13 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?rev=1.352&view=markup
14 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?rev=1.352&content-type=text/plain
15 diff : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?r1=1.351&r2=1.352
16
17 Index: ChangeLog
18 ===================================================================
19 RCS file: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v
20 retrieving revision 1.351
21 retrieving revision 1.352
22 diff -u -r1.351 -r1.352
23 --- ChangeLog 30 Jul 2015 19:00:13 -0000 1.351
24 +++ ChangeLog 31 Jul 2015 15:10:38 -0000 1.352
25 @@ -1,6 +1,11 @@
26 # ChangeLog for dev-vcs/git
27 # Copyright 1999-2015 Gentoo Foundation; Distributed under the GPL v2
28 -# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.351 2015/07/30 19:00:13 zlogene Exp $
29 +# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.352 2015/07/31 15:10:38 polynomial-c Exp $
30 +
31 +*git-2.4.7 (31 Jul 2015)
32 +
33 + 31 Jul 2015; Lars Wendler <polynomial-c@g.o> +git-2.4.7.ebuild:
34 + Version bump.
35
36 30 Jul 2015; Mikle Kolyada <zlogene@g.o> git-2.3.8.ebuild,
37 git-2.4.6.ebuild:
38
39
40
41 1.1 dev-vcs/git/git-2.4.7.ebuild
42
43 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/git-2.4.7.ebuild?rev=1.1&view=markup
44 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/git-2.4.7.ebuild?rev=1.1&content-type=text/plain
45
46 Index: git-2.4.7.ebuild
47 ===================================================================
48 # Copyright 1999-2015 Gentoo Foundation
49 # Distributed under the terms of the GNU General Public License v2
50 # $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/git-2.4.7.ebuild,v 1.1 2015/07/31 15:10:38 polynomial-c Exp $
51
52 EAPI=5
53
54 GENTOO_DEPEND_ON_PERL=no
55
56 # bug #329479: git-remote-testgit is not multiple-version aware
57 PYTHON_COMPAT=( python2_7 )
58 [[ ${PV} == *9999 ]] && SCM="git-2"
59 EGIT_REPO_URI="git://git.kernel.org/pub/scm/git/git.git"
60 EGIT_MASTER=pu
61
62 inherit toolchain-funcs eutils elisp-common perl-module bash-completion-r1 python-single-r1 systemd ${SCM}
63
64 MY_PV="${PV/_rc/.rc}"
65 MY_P="${PN}-${MY_PV}"
66
67 DOC_VER=${MY_PV}
68
69 DESCRIPTION="GIT - the stupid content tracker, the revision control system heavily used by the Linux kernel team"
70 HOMEPAGE="http://www.git-scm.com/"
71 if [[ ${PV} != *9999 ]]; then
72 SRC_URI_SUFFIX="xz"
73 SRC_URI_GOOG="http://git-core.googlecode.com/files"
74 SRC_URI_KORG="mirror://kernel/software/scm/git"
75 SRC_URI="${SRC_URI_GOOG}/${MY_P}.tar.${SRC_URI_SUFFIX}
76 ${SRC_URI_KORG}/${MY_P}.tar.${SRC_URI_SUFFIX}
77 ${SRC_URI_GOOG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
78 ${SRC_URI_KORG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
79 doc? (
80 ${SRC_URI_KORG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
81 ${SRC_URI_GOOG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
82 )"
83 KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~ppc-aix ~amd64-fbsd ~sparc-fbsd ~x86-fbsd ~x64-freebsd ~x86-freebsd ~ia64-hpux ~x86-interix ~amd64-linux ~arm-linux ~ia64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
84 fi
85
86 LICENSE="GPL-2"
87 SLOT="0"
88 IUSE="+blksha1 +curl cgi doc emacs gnome-keyring +gpg gtk highlight +iconv mediawiki +nls +pcre +perl +python ppcsha1 tk +threads +webdav xinetd cvs subversion test"
89
90 # Common to both DEPEND and RDEPEND
91 CDEPEND="
92 dev-libs/openssl:0=
93 sys-libs/zlib
94 pcre? ( dev-libs/libpcre )
95 perl? ( dev-lang/perl:=[-build(-)] )
96 tk? ( dev-lang/tk:= )
97 curl? (
98 net-misc/curl
99 webdav? ( dev-libs/expat )
100 )
101 emacs? ( virtual/emacs )
102 gnome-keyring? ( gnome-base/libgnome-keyring )"
103
104 RDEPEND="${CDEPEND}
105 gpg? ( app-crypt/gnupg )
106 mediawiki? (
107 dev-perl/HTML-Tree
108 dev-perl/MediaWiki-API
109 )
110 perl? ( dev-perl/Error
111 dev-perl/Net-SMTP-SSL
112 dev-perl/Authen-SASL
113 cgi? ( dev-perl/CGI highlight? ( app-text/highlight ) )
114 cvs? ( >=dev-vcs/cvsps-2.1:0 dev-perl/DBI dev-perl/DBD-SQLite )
115 subversion? ( dev-vcs/subversion[-dso,perl] dev-perl/libwww-perl dev-perl/TermReadKey )
116 )
117 python? ( gtk?
118 (
119 >=dev-python/pygtk-2.8[${PYTHON_USEDEP}]
120 >=dev-python/pygtksourceview-2.10.1-r1:2[${PYTHON_USEDEP}]
121 )
122 ${PYTHON_DEPS} )"
123
124 # This is how info docs are created with Git:
125 # .txt/asciidoc --(asciidoc)---------> .xml/docbook
126 # .xml/docbook --(docbook2texi.pl)--> .texi
127 # .texi --(makeinfo)---------> .info
128 DEPEND="${CDEPEND}
129 doc? (
130 app-text/asciidoc
131 app-text/docbook2X
132 sys-apps/texinfo
133 app-text/xmlto
134 )
135 nls? ( sys-devel/gettext )
136 test? ( app-crypt/gnupg )"
137
138 # Live ebuild builds man pages and HTML docs, additionally
139 if [[ ${PV} == *9999 ]]; then
140 DEPEND="${DEPEND}
141 app-text/asciidoc"
142 fi
143
144 SITEFILE=50${PN}-gentoo.el
145 S="${WORKDIR}/${MY_P}"
146
147 REQUIRED_USE="
148 cgi? ( perl )
149 cvs? ( perl )
150 mediawiki? ( perl )
151 subversion? ( perl )
152 webdav? ( curl )
153 gtk? ( python )
154 python? ( ${PYTHON_REQUIRED_USE} )
155 "
156
157 pkg_setup() {
158 if use subversion && has_version "dev-vcs/subversion[dso]"; then
159 ewarn "Per Gentoo bugs #223747, #238586, when subversion is built"
160 ewarn "with USE=dso, there may be weird crashes in git-svn. You"
161 ewarn "have been warned."
162 fi
163 if use python ; then
164 python-single-r1_pkg_setup
165 fi
166 }
167
168 # This is needed because for some obscure reasons future calls to make don't
169 # pick up these exports if we export them in src_unpack()
170 exportmakeopts() {
171 local myopts
172
173 if use blksha1 ; then
174 myopts+=" BLK_SHA1=YesPlease"
175 elif use ppcsha1 ; then
176 myopts+=" PPC_SHA1=YesPlease"
177 fi
178
179 if use curl ; then
180 use webdav || myopts+=" NO_EXPAT=YesPlease"
181 else
182 myopts+=" NO_CURL=YesPlease"
183 fi
184
185 # broken assumptions, because of broken build system ...
186 myopts+=" NO_FINK=YesPlease NO_DARWIN_PORTS=YesPlease"
187 myopts+=" INSTALL=install TAR=tar"
188 myopts+=" SHELL_PATH=${EPREFIX}/bin/sh"
189 myopts+=" SANE_TOOL_PATH="
190 myopts+=" OLD_ICONV="
191 myopts+=" NO_EXTERNAL_GREP="
192
193 # For svn-fe
194 extlibs="-lz -lssl ${S}/xdiff/lib.a $(usex threads -lpthread '')"
195
196 # can't define this to null, since the entire makefile depends on it
197 sed -i -e '/\/usr\/local/s/BASIC_/#BASIC_/' Makefile
198
199 use iconv \
200 || myopts+=" NO_ICONV=YesPlease"
201 use nls \
202 || myopts+=" NO_GETTEXT=YesPlease"
203 use tk \
204 || myopts+=" NO_TCLTK=YesPlease"
205 use pcre \
206 && myopts+=" USE_LIBPCRE=yes" \
207 && extlibs+=" -lpcre"
208 use perl \
209 && myopts+=" INSTALLDIRS=vendor" \
210 || myopts+=" NO_PERL=YesPlease"
211 use python \
212 || myopts+=" NO_PYTHON=YesPlease"
213 use subversion \
214 || myopts+=" NO_SVN_TESTS=YesPlease"
215 use threads \
216 && myopts+=" THREADED_DELTA_SEARCH=YesPlease" \
217 || myopts+=" NO_PTHREADS=YesPlease"
218 use cvs \
219 || myopts+=" NO_CVS=YesPlease"
220 # Disabled until ~m68k-mint can be keyworded again
221 # if [[ ${CHOST} == *-mint* ]] ; then
222 # myopts+=" NO_MMAP=YesPlease"
223 # myopts+=" NO_IPV6=YesPlease"
224 # myopts+=" NO_STRLCPY=YesPlease"
225 # myopts+=" NO_MEMMEM=YesPlease"
226 # myopts+=" NO_MKDTEMP=YesPlease"
227 # myopts+=" NO_MKSTEMPS=YesPlease"
228 # fi
229 if [[ ${CHOST} == ia64-*-hpux* ]]; then
230 myopts+=" NO_NSEC=YesPlease"
231 fi
232 if [[ ${CHOST} == *-*-aix* ]]; then
233 myopts+=" NO_FNMATCH_CASEFOLD=YesPlease"
234 fi
235 if [[ ${CHOST} == *-solaris* ]]; then
236 myopts+=" NEEDS_LIBICONV=YesPlease"
237 fi
238
239 has_version '>=app-text/asciidoc-8.0' \
240 && myopts+=" ASCIIDOC8=YesPlease"
241 myopts+=" ASCIIDOC_NO_ROFF=YesPlease"
242
243 # Bug 290465:
244 # builtin-fetch-pack.c:816: error: 'struct stat' has no member named 'st_mtim'
245 [[ "${CHOST}" == *-uclibc* ]] && \
246 myopts+=" NO_NSEC=YesPlease"
247
248 export MY_MAKEOPTS="${myopts}"
249 export EXTLIBS="${extlibs}"
250 }
251
252 src_unpack() {
253 if [[ ${PV} != *9999 ]]; then
254 unpack ${MY_P}.tar.${SRC_URI_SUFFIX}
255 cd "${S}"
256 unpack ${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
257 use doc && \
258 cd "${S}"/Documentation && \
259 unpack ${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
260 cd "${S}"
261 else
262 git-2_src_unpack
263 cd "${S}"
264 #cp "${FILESDIR}"/GIT-VERSION-GEN .
265 fi
266
267 }
268
269 src_prepare() {
270 # bug #350330 - automagic CVS when we don't want it is bad.
271 epatch "${FILESDIR}"/git-2.2.2-optional-cvs.patch
272
273 # install mediawiki perl modules also in vendor_dir
274 # hack, needs better upstream solution
275 epatch "${FILESDIR}"/git-1.8.5-mw-vendor.patch
276
277 epatch "${FILESDIR}"/git-2.2.0-svn-fe-linking.patch
278
279 epatch_user
280
281 sed -i \
282 -e 's:^\(CFLAGS[[:space:]]*=\).*$:\1 $(OPTCFLAGS) -Wall:' \
283 -e 's:^\(LDFLAGS[[:space:]]*=\).*$:\1 $(OPTLDFLAGS):' \
284 -e 's:^\(CC[[:space:]]* =\).*$:\1$(OPTCC):' \
285 -e 's:^\(AR[[:space:]]* =\).*$:\1$(OPTAR):' \
286 -e "s:\(PYTHON_PATH[[:space:]]\+=[[:space:]]\+\)\(.*\)$:\1${EPREFIX}\2:" \
287 -e "s:\(PERL_PATH[[:space:]]\+=[[:space:]]\+\)\(.*\)$:\1${EPREFIX}\2:" \
288 Makefile contrib/svn-fe/Makefile || die "sed failed"
289
290 # Never install the private copy of Error.pm (bug #296310)
291 sed -i \
292 -e '/private-Error.pm/s,^,#,' \
293 perl/Makefile.PL
294
295 # Fix docbook2texi command
296 sed -r -i 's/DOCBOOK2X_TEXI[[:space:]]*=[[:space:]]*docbook2x-texi/DOCBOOK2X_TEXI = docbook2texi.pl/' \
297 Documentation/Makefile || die "sed failed"
298
299 # Fix git-subtree missing DESTDIR
300 sed -i \
301 -e '/$(INSTALL)/s/ $(libexecdir)/ $(DESTDIR)$(libexecdir)/g' \
302 -e '/$(INSTALL)/s/ $(man1dir)/ $(DESTDIR)$(man1dir)/g' \
303 contrib/subtree/Makefile
304 }
305
306 git_emake() {
307 # bug #326625: PERL_PATH, PERL_MM_OPT
308 # bug #320647: PYTHON_PATH
309 PYTHON_PATH=""
310 use python && PYTHON_PATH="${PYTHON}"
311 emake ${MY_MAKEOPTS} \
312 DESTDIR="${D}" \
313 OPTCFLAGS="${CFLAGS}" \
314 OPTLDFLAGS="${LDFLAGS}" \
315 OPTCC="$(tc-getCC)" \
316 OPTAR="$(tc-getAR)" \
317 prefix="${EPREFIX}"/usr \
318 htmldir="${EPREFIX}"/usr/share/doc/${PF}/html \
319 sysconfdir="${EPREFIX}"/etc \
320 PYTHON_PATH="${PYTHON_PATH}" \
321 PERL_MM_OPT="" \
322 GIT_TEST_OPTS="--no-color" \
323 V=1 \
324 "$@"
325 # This is the fix for bug #326625, but it also causes breakage, see bug
326 # #352693.
327 # PERL_PATH="${EPREFIX}/usr/bin/env perl" \
328 }
329
330 src_configure() {
331 exportmakeopts
332 }
333
334 src_compile() {
335 if use perl ; then
336 git_emake perl/PM.stamp || die "emake perl/PM.stamp failed"
337 git_emake perl/perl.mak || die "emake perl/perl.mak failed"
338 fi
339 git_emake || die "emake failed"
340
341 if use emacs ; then
342 elisp-compile contrib/emacs/git{,-blame}.el
343 fi
344
345 if use perl && use cgi ; then
346 git_emake \
347 gitweb \
348 || die "emake gitweb (cgi) failed"
349 fi
350
351 if [[ ${CHOST} == *-darwin* ]]; then
352 cd "${S}"/contrib/credential/osxkeychain || die "cd credential/osxkeychain"
353 git_emake || die "emake credential-osxkeychain"
354 fi
355
356 cd "${S}"/Documentation
357 if [[ ${PV} == *9999 ]] ; then
358 git_emake man \
359 || die "emake man failed"
360 if use doc ; then
361 git_emake info html \
362 || die "emake info html failed"
363 fi
364 else
365 if use doc ; then
366 git_emake info \
367 || die "emake info html failed"
368 fi
369 fi
370
371 if use subversion ; then
372 cd "${S}"/contrib/svn-fe
373 # by defining EXTLIBS we override the detection for libintl and
374 # libiconv, bug #516168
375 local nlsiconv=
376 use nls && use !elibc_glibc && nlsiconv+=" -lintl"
377 use iconv && use !elibc_glibc && nlsiconv+=" -liconv"
378 git_emake EXTLIBS="${EXTLIBS} ${nlsiconv}" || die "emake svn-fe failed"
379 if use doc ; then
380 git_emake svn-fe.{1,html} || die "emake svn-fe.1 svn-fe.html failed"
381 fi
382 cd "${S}"
383 fi
384
385 if use gnome-keyring ; then
386 cd "${S}"/contrib/credential/gnome-keyring
387 git_emake || die "emake git-credential-gnome-keyring failed"
388 fi
389
390 cd "${S}"/contrib/subtree
391 git_emake
392 use doc && git_emake doc
393
394 if use mediawiki ; then
395 cd "${S}"/contrib/mw-to-git
396 git_emake
397 fi
398 }
399
400 src_install() {
401 git_emake \
402 install || \
403 die "make install failed"
404
405 if [[ ${CHOST} == *-darwin* ]]; then
406 dobin contrib/credential/osxkeychain/git-credential-osxkeychain
407 fi
408
409 # Depending on the tarball and manual rebuild of the documentation, the
410 # manpages may exist in either OR both of these directories.
411 find man?/*.[157] >/dev/null 2>&1 && doman man?/*.[157]
412 find Documentation/*.[157] >/dev/null 2>&1 && doman Documentation/*.[157]
413
414 dodoc README Documentation/{SubmittingPatches,CodingGuidelines}
415 use doc && dodir /usr/share/doc/${PF}/html
416 for d in / /howto/ /technical/ ; do
417 docinto ${d}
418 dodoc Documentation${d}*.txt
419 use doc && dohtml -p ${d} Documentation${d}*.html
420 done
421 docinto /
422 # Upstream does not ship this pre-built :-(
423 use doc && doinfo Documentation/{git,gitman}.info
424
425 newbashcomp contrib/completion/git-completion.bash ${PN}
426 bashcomp_alias git gitk
427 # Not really a bash-completion file (bug #477920)
428 # but still needed uncompressed (bug #507480)
429 insinto /usr/share/${PN}
430 doins contrib/completion/git-prompt.sh
431
432 if use emacs ; then
433 elisp-install ${PN} contrib/emacs/git.{el,elc}
434 elisp-install ${PN} contrib/emacs/git-blame.{el,elc}
435 #elisp-install ${PN}/compat contrib/emacs/vc-git.{el,elc}
436 # don't add automatically to the load-path, so the sitefile
437 # can do a conditional loading
438 touch "${ED}${SITELISP}/${PN}/compat/.nosearch"
439 elisp-site-file-install "${FILESDIR}"/${SITEFILE}
440 fi
441
442 if use python && use gtk ; then
443 python_doscript "${S}"/contrib/gitview/gitview
444 dodoc "${S}"/contrib/gitview/gitview.txt
445 fi
446
447 #dobin contrib/fast-import/git-p4 # Moved upstream
448 #dodoc contrib/fast-import/git-p4.txt # Moved upstream
449 newbin contrib/fast-import/import-tars.perl import-tars
450 exeinto /usr/libexec/git-core/
451 newexe contrib/git-resurrect.sh git-resurrect
452
453 # git-subtree
454 cd "${S}"/contrib/subtree
455 git_emake install || die "Failed to emake install git-subtree"
456 if use doc ; then
457 git_emake install-man install-doc || die "Failed to emake install-doc install-mangit-subtree"
458 fi
459 newdoc README README.git-subtree
460 dodoc git-subtree.txt
461 cd "${S}"
462
463 if use mediawiki ; then
464 cd "${S}"/contrib/mw-to-git
465 git_emake install
466 cd "${S}"
467 fi
468
469 # diff-highlight
470 dobin contrib/diff-highlight/diff-highlight
471 newdoc contrib/diff-highlight/README README.diff-highlight
472
473 # git-jump
474 exeinto /usr/libexec/git-core/
475 doexe contrib/git-jump/git-jump
476 newdoc contrib/git-jump/README git-jump.txt
477
478 # git-contacts
479 exeinto /usr/libexec/git-core/
480 doexe contrib/contacts/git-contacts
481 dodoc contrib/contacts/git-contacts.txt
482
483 if use gnome-keyring ; then
484 cd "${S}"/contrib/credential/gnome-keyring
485 dobin git-credential-gnome-keyring
486 fi
487
488 if use subversion ; then
489 cd "${S}"/contrib/svn-fe
490 dobin svn-fe
491 dodoc svn-fe.txt
492 use doc && doman svn-fe.1 && dohtml svn-fe.html
493 cd "${S}"
494 fi
495
496 dodir /usr/share/${PN}/contrib
497 # The following are excluded:
498 # completion - installed above
499 # credential/gnome-keyring TODO
500 # diff-highlight - done above
501 # emacs - installed above
502 # examples - these are stuff that is not used in Git anymore actually
503 # git-jump - done above
504 # gitview - installed above
505 # p4import - excluded because fast-import has a better one
506 # patches - stuff the Git guys made to go upstream to other places
507 # persistent-https - TODO
508 # mw-to-git - TODO
509 # subtree - build seperately
510 # svnimport - use git-svn
511 # thunderbird-patch-inline - fixes thunderbird
512 for i in \
513 buildsystems convert-objects fast-import \
514 hg-to-git hooks remotes2config.sh rerere-train.sh \
515 stats workdir \
516 ; do
517 cp -rf \
518 "${S}"/contrib/${i} \
519 "${ED}"/usr/share/${PN}/contrib \
520 || die "Failed contrib ${i}"
521 done
522
523 if use perl && use cgi ; then
524 # We used to install in /usr/share/${PN}/gitweb
525 # but upstream installs in /usr/share/gitweb
526 # so we will install a symlink and use their location for compat with other
527 # distros
528 dosym /usr/share/gitweb /usr/share/${PN}/gitweb
529
530 # INSTALL discusses configuration issues, not just installation
531 docinto /
532 newdoc "${S}"/gitweb/INSTALL INSTALL.gitweb
533 newdoc "${S}"/gitweb/README README.gitweb
534
535 find "${ED}"/usr/lib64/perl5/ \
536 -name .packlist \
537 -exec rm \{\} \;
538 else
539 rm -rf "${ED}"/usr/share/gitweb
540 fi
541
542 if ! use subversion ; then
543 rm -f "${ED}"/usr/libexec/git-core/git-svn \
544 "${ED}"/usr/share/man/man1/git-svn.1*
545 fi
546
547 if use xinetd ; then
548 insinto /etc/xinetd.d
549 newins "${FILESDIR}"/git-daemon.xinetd git-daemon
550 fi
551
552 if use !prefix ; then
553 newinitd "${FILESDIR}"/git-daemon-r1.initd git-daemon
554 newconfd "${FILESDIR}"/git-daemon.confd git-daemon
555 systemd_newunit "${FILESDIR}/git-daemon_at.service" "git-daemon@.service"
556 systemd_dounit "${FILESDIR}/git-daemon.socket"
557 fi
558
559 perl_delete_localpod
560 }
561
562 src_test() {
563 local disabled="" #t7004-tag.sh" #520270
564 local tests_cvs="t9200-git-cvsexportcommit.sh \
565 t9400-git-cvsserver-server.sh \
566 t9401-git-cvsserver-crlf.sh \
567 t9402-git-cvsserver-refs.sh \
568 t9600-cvsimport.sh \
569 t9601-cvsimport-vendor-branch.sh \
570 t9602-cvsimport-branches-tags.sh \
571 t9603-cvsimport-patchsets.sh \
572 t9604-cvsimport-timestamps.sh"
573 local tests_perl="t3701-add-interactive.sh \
574 t5502-quickfetch.sh \
575 t5512-ls-remote.sh \
576 t5520-pull.sh \
577 t7106-reset-unborn-branch.sh \
578 t7501-commit.sh"
579 # Bug #225601 - t0004 is not suitable for root perm
580 # Bug #219839 - t1004 is not suitable for root perm
581 # t0001-init.sh - check for init notices EPERM* fails
582 local tests_nonroot="t0001-init.sh \
583 t0004-unwritable.sh \
584 t0070-fundamental.sh \
585 t1004-read-tree-m-u-wf.sh \
586 t3700-add.sh \
587 t7300-clean.sh"
588 # t9100 still fails with symlinks in SVN 1.7
589 local test_svn="t9100-git-svn-basic.sh"
590
591 # Unzip is used only for the testcase code, not by any normal parts of Git.
592 if ! has_version app-arch/unzip ; then
593 einfo "Disabling tar-tree tests"
594 disabled="${disabled} t5000-tar-tree.sh"
595 fi
596
597 cvs=0
598 use cvs && let cvs=$cvs+1
599 if [[ ${EUID} -eq 0 ]]; then
600 if [[ $cvs -eq 1 ]]; then
601 ewarn "Skipping CVS tests because CVS does not work as root!"
602 ewarn "You should retest with FEATURES=userpriv!"
603 disabled="${disabled} ${tests_cvs}"
604 fi
605 einfo "Skipping other tests that require being non-root"
606 disabled="${disabled} ${tests_nonroot}"
607 else
608 [[ $cvs -gt 0 ]] && \
609 has_version dev-vcs/cvs && \
610 let cvs=$cvs+1
611 [[ $cvs -gt 1 ]] && \
612 has_version "dev-vcs/cvs[server]" && \
613 let cvs=$cvs+1
614 if [[ $cvs -lt 3 ]]; then
615 einfo "Disabling CVS tests (needs dev-vcs/cvs[USE=server])"
616 disabled="${disabled} ${tests_cvs}"
617 fi
618 fi
619
620 if ! use perl ; then
621 einfo "Disabling tests that need Perl"
622 disabled="${disabled} ${tests_perl}"
623 fi
624
625 einfo "Disabling tests that fail with SVN 1.7"
626 disabled="${disabled} ${test_svn}"
627
628 # Reset all previously disabled tests
629 cd "${S}/t"
630 for i in *.sh.DISABLED ; do
631 [[ -f "${i}" ]] && mv -f "${i}" "${i%.DISABLED}"
632 done
633 einfo "Disabled tests:"
634 for i in ${disabled} ; do
635 [[ -f "${i}" ]] && mv -f "${i}" "${i}.DISABLED" && einfo "Disabled $i"
636 done
637
638 # Avoid the test system removing the results because we want them ourselves
639 sed -e '/^[[:space:]]*$(MAKE) clean/s,^,#,g' \
640 -i "${S}"/t/Makefile
641
642 # Clean old results first, must always run
643 cd "${S}/t"
644 nonfatal git_emake clean
645
646 # Now run the tests, keep going if we hit an error, and don't terminate on
647 # failure
648 cd "${S}"
649 einfo "Start test run"
650 #MAKEOPTS=-j1
651 nonfatal git_emake --keep-going test
652 rc=$?
653
654 # Display nice results, now print the results
655 cd "${S}/t"
656 nonfatal git_emake aggregate-results
657
658 # And bail if there was a problem
659 [ $rc -eq 0 ] || die "tests failed. Please file a bug."
660 }
661
662 showpkgdeps() {
663 local pkg=$1
664 shift
665 elog " $(printf "%-17s:" ${pkg}) ${@}"
666 }
667
668 pkg_postinst() {
669 use emacs && elisp-site-regen
670 einfo "Please read /usr/share/bash-completion/git for Git bash command completion"
671 einfo "Please read /usr/share/git/git-prompt.sh for Git bash prompt"
672 einfo "Note that the prompt bash code is now in that separate script"
673 elog "These additional scripts need some dependencies:"
674 echo
675 showpkgdeps git-quiltimport "dev-util/quilt"
676 showpkgdeps git-instaweb \
677 "|| ( www-servers/lighttpd www-servers/apache www-servers/nginx )"
678 echo
679 }
680
681 pkg_postrm() {
682 use emacs && elisp-site-regen
683 }